# ybbok-front\.gitlab-ci.yml

stages:
  - build
  - test
  - docker-build
  - deploy

variables:
  IMAGE_TAG: $CI_COMMIT_REF_SLUG
  IMAGE_NAME: ybook-front

build:
  stage: build
  image: node:latest
  script: 
    - echo "Start building App"
    - npm install 
    - npm run build
    - echo "Build successfully!"
  artifacts:
    expire_in: 1 hour
    paths:
      - build
      - node_modules/
  tags:
    - docker

test:
  stage: test
  image: node:latest
  script:
    - echo "Testing App"
    - CI=true npm test
    - echo "Test successfully!"
  tags:
  - docker

docker-build:
  stage: docker-build
  image: docker:latest
  services: 
    - name: docker:19.03.8-dind
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - echo "Building docker image"
    - docker build -t "$CI_REGISTRY_IMAGE:$IMAGE_TAG" .
    - docker push "$CI_REGISTRY_IMAGE:$IMAGE_TAG"
    - echo "Docker image successfully built!"
    - echo "Image :\ $CI_REGISTRY_IMAGE:$IMAGE_TAG"
  only:
    - main
    - master  
  tags:
    - docker

deploy:
  stage: deploy
  image: kroniak/ssh-client
  before_script:
    - echo "Deploying the App to Digital Ocean"
  script:
    - chmod 400 $SSH_KEY
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY root@$SERVER_IP "docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY"
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY root@$SERVER_IP "docker pull registry.gitlab.com/rmarieh_/ynov/M1/pipeline/ybook-front"
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY root@$SERVER_IP "docker stop ybook-front"
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY root@$SERVER_IP "docker run -d --name ybook-front -p 80:80 registry.gitlab.com/rmariehme/ynov/m1/pipeline/ybook-front"
  only:
    - main
    - master
  tags:
    - docker